searchData={"content_type":"text/markdown","items":[{"doc":"","ref":"Extism.html","title":"Extism","type":"module"},{"doc":"","ref":"Extism.html#set_log_file/2","title":"Extism.set_log_file/2","type":"function"},{"doc":"A CancelHandle is a handle generated by a plugin that allows it to be cancelled from another\nthread while running.","ref":"Extism.CancelHandle.html","title":"Extism.CancelHandle","type":"module"},{"doc":"Cancel plugin execution","ref":"Extism.CancelHandle.html#cancel/1","title":"Extism.CancelHandle.cancel/1","type":"function"},{"doc":"","ref":"Extism.CancelHandle.html#wrap_resource/1","title":"Extism.CancelHandle.wrap_resource/1","type":"function"},{"doc":"This module represents the Native Extism runtime API and is for internal use.\nDo not use or rely on this this module.","ref":"Extism.Native.html","title":"Extism.Native","type":"module"},{"doc":"","ref":"Extism.Native.html#plugin_call/3","title":"Extism.Native.plugin_call/3","type":"function"},{"doc":"","ref":"Extism.Native.html#plugin_cancel/1","title":"Extism.Native.plugin_cancel/1","type":"function"},{"doc":"","ref":"Extism.Native.html#plugin_cancel_handle/1","title":"Extism.Native.plugin_cancel_handle/1","type":"function"},{"doc":"","ref":"Extism.Native.html#plugin_free/1","title":"Extism.Native.plugin_free/1","type":"function"},{"doc":"","ref":"Extism.Native.html#plugin_has_function/2","title":"Extism.Native.plugin_has_function/2","type":"function"},{"doc":"","ref":"Extism.Native.html#plugin_new_with_manifest/2","title":"Extism.Native.plugin_new_with_manifest/2","type":"function"},{"doc":"","ref":"Extism.Native.html#set_log_file/2","title":"Extism.Native.set_log_file/2","type":"function"},{"doc":"A Plugin represents an instance of your WASM program from the given manifest.","ref":"Extism.Plugin.html","title":"Extism.Plugin","type":"module"},{"doc":"Call a plugin's function by name","ref":"Extism.Plugin.html#call/3","title":"Extism.Plugin.call/3","type":"function"},{"doc":"iex> {:ok, plugin} = Extism.Plugin.new(manifest, false)\n    iex> {:ok, output} = Extism.Plugin.call(plugin, \"count_vowels\", \"this is a test\")\n       # {:ok, \"{\"count\": 4}\"}","ref":"Extism.Plugin.html#call/3-examples","title":"Examples - Extism.Plugin.call/3","type":"function"},{"doc":"- plugin: The plugin\n  - name: The name of the function as a string\n  - input: The input data as a string","ref":"Extism.Plugin.html#call/3-parameters","title":"Parameters - Extism.Plugin.call/3","type":"function"},{"doc":"A string representation of the functions output","ref":"Extism.Plugin.html#call/3-returns","title":"Returns - Extism.Plugin.call/3","type":"function"},{"doc":"Frees the plugin","ref":"Extism.Plugin.html#free/1","title":"Extism.Plugin.free/1","type":"function"},{"doc":"Returns true if the given plugin responds to the given function name","ref":"Extism.Plugin.html#has_function/2","title":"Extism.Plugin.has_function/2","type":"function"},{"doc":"Creates a new plugin","ref":"Extism.Plugin.html#new/2","title":"Extism.Plugin.new/2","type":"function"},{"doc":"","ref":"Extism.Plugin.html#wrap_resource/1","title":"Extism.Plugin.wrap_resource/1","type":"function"},{"doc":"# Extism\n\nExtism Host SDK for Elixir and Erlang","ref":"readme.html","title":"Extism","type":"extras"},{"doc":"Read the [docs on hexdocs.pm](https://hexdocs.pm/extism/).","ref":"readme.html#docs","title":"Docs - Extism","type":"extras"},{"doc":"You can find this package on [hex.pm](https://hex.pm/packages/extism).\n\n```elixir\ndef deps do\n  [\n    {:extism, \"~> 0.1.0\"}\n  ]\nend\n```","ref":"readme.html#installation","title":"Installation - Extism","type":"extras"},{"doc":"#","ref":"readme.html#getting-started","title":"Getting Started - Extism","type":"extras"},{"doc":"```elixir\n# point to some wasm code, this is the count_vowels example that ships with extism\nmanifest = %{ wasm: [ %{ path: \"/Users/ben/code/extism/wasm/code.wasm\" } ]}\n{:ok, plugin} = Extism.Plugin.new(manifest, false)\n# {:ok,\n# %Extism.Plugin{\n#   resource: 0,\n#   reference: #Reference \n# }}\n{:ok, output} = Extism.Plugin.call(plugin, \"count_vowels\", \"this is a test\")\n# {:ok, \"{\\\"count\\\": 4}\"}\n{:ok, result} = JSON.decode(output)\n# {:ok, %{\"count\" => 4}}\n```\n\n#","ref":"readme.html#example","title":"Example - Extism","type":"extras"},{"doc":"The primary modules you should learn is:\n\n* [Extism.Plugin](Extism.Plugin.html)\n\n##","ref":"readme.html#modules","title":"Modules - Extism","type":"extras"},{"doc":"The [Plugin](Extism.Plugin.html) represents an instance of your WASM program from the given manifest.\nThe key method to know here is [Extism.Plugin#call](Extism.Plugin.html#call/3) which takes a function name to invoke and some input data, and returns the results from the plugin.\n\n```elixir\n{:ok, plugin} = Extism.Plugin.new(manifest, false)\n{:ok, output} = Extism.Plugin.call(plugin, \"count_vowels\", \"this is a test\")\n```","ref":"readme.html#plugin","title":"Plugin - Extism","type":"extras"}]}